#include "all.h"

#include <unistd.h>
#include <sys/wait.h>
#include <fcntl.h>

static guard g(__FILE__);

int main() {
    char buf[100];
    int fd = open("/proc/self/maps", O_RDONLY);
    while(1) {
	int count = read(fd, buf, sizeof(buf));
	if(count <= 0)
	    break;
	fprintf(stderr, "%.*s", count, buf);
    }
    fprintf(stderr, "\nBefore fork\n");
    
    if(pid_t pid = fork()) {
	// parent
	fprintf(stderr, "Parent after fork (child: %d)\n", pid);
	int status;
	wait(&status);
	fprintf(stderr, "Parent exiting\n");
    }
    else {
	fprintf(stderr, "Child after fork\n");
	foo();
	bar();
	fprintf(stderr, "Child exiting\n");
    }
}
